Package org.eclipse.gef.common.collections

# Class SetListenerHelperEx<E>

java.lang.Object
org.eclipse.gef.common.collections.SetListenerHelperEx<E>

Type Parameters:
  `E` - The element type of the `ObservableSet`.

Direct Known Subclasses:
  `SetExpressionHelperEx`

public class SetListenerHelperEx<E> extends Object
A utility class to support change notifications for an `ObservableSet` , replacing the JavaFX-internal `SetChangeListener` helper class.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`SetListenerHelperEx.AtomicChange<E>`
A simple implementation of an `SetChangeListener.Change`.

## Constructor Summary

Constructors
Constructor
Description
`SetListenerHelperEx(javafx.collections.ObservableSet<E> source)`
Constructs a new `SetListenerHelperEx` for the given source `ObservableSet`.

## Method Summary

Modifier and Type
Method
Description
`void`
`addListener(javafx.beans.InvalidationListener listener)`
Adds a new `InvalidationListener` to this `SetListenerHelperEx`.
`void`
`addListener(javafx.collections.SetChangeListener<? super E> listener)`
Adds a new `SetChangeListener` to this `SetListenerHelperEx`.
`void`
`fireValueChangedEvent(javafx.collections.SetChangeListener.Change<? extends E> change)`
Notifies all attached `InvalidationListener`s and `SetChangeListener`s about the change.
`protected javafx.collections.ObservableSet<E>`
`getSource()`
Returns the source `ObservableSet` this `SetListenerHelperEx` is bound to, which is used in change notifications.
`protected void`
`notifyInvalidationListeners()`
Notifies all registered `InvalidationListener`s.
`protected void`
`notifySetChangeListeners(javafx.collections.SetChangeListener.Change<? extends E> change)`
Notifies the attached `SetChangeListener`s about the related change.
`void`
`removeListener(javafx.beans.InvalidationListener listener)`
Removes the given `InvalidationListener` from this `SetListenerHelperEx`.
`void`
`removeListener(javafx.collections.SetChangeListener<? super E> listener)`
Removes the given `SetChangeListener` from this `SetListenerHelperEx`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### SetListenerHelperEx

public SetListenerHelperEx(javafx.collections.ObservableSet<E> source)
Constructs a new `SetListenerHelperEx` for the given source `ObservableSet`.

Parameters:
  `source` - The `ObservableSet` to use as source in change notifications.

## Method Details

### addListener

public void addListener(javafx.beans.InvalidationListener listener)
Adds a new `InvalidationListener` to this `SetListenerHelperEx`. If the same listener is added more than once, it will be registered more than once and will receive multiple change events.

Parameters:
  `listener` - The listener to add.

### addListener

public void addListener(javafx.collections.SetChangeListener<? super E> listener)
Adds a new `SetChangeListener` to this `SetListenerHelperEx`. If the same listener is added more than once, it will be registered more than once and will receive multiple change events.

Parameters:
  `listener` - The listener to add.

### fireValueChangedEvent

public void fireValueChangedEvent(javafx.collections.SetChangeListener.Change<? extends E> change)
Notifies all attached `InvalidationListener`s and `SetChangeListener`s about the change.

Parameters:
  `change` - The change to notify listeners about.

### getSource

protected javafx.collections.ObservableSet<E> getSource()
Returns the source `ObservableSet` this `SetListenerHelperEx` is bound to, which is used in change notifications.

Returns:
  The source `ObservableSet`.

### notifyInvalidationListeners

protected void notifyInvalidationListeners()
Notifies all registered `InvalidationListener`s.

### notifySetChangeListeners

protected void notifySetChangeListeners(javafx.collections.SetChangeListener.Change<? extends E> change)
Notifies the attached `SetChangeListener`s about the related change.

Parameters:
  `change` - The applied change.

### removeListener

public void removeListener(javafx.beans.InvalidationListener listener)
Removes the given `InvalidationListener` from this `SetListenerHelperEx`. If its was registered more than once, removes one occurrence.

Parameters:
  `listener` - The listener to remove.

### removeListener

public void removeListener(javafx.collections.SetChangeListener<? super E> listener)
Removes the given `SetChangeListener` from this `SetListenerHelperEx`. If its was registered more than once, removes one occurrence.

Parameters:
  `listener` - The listener to remove.